#include <stdio.h>
#include <stdlib.h>
#ifdef SIMD
#include <xmmintrin.h>
#endif

int
main(void)
{
	float res, *v1, *v2;
#ifdef SIMD
	float buf[4];
	__m128 m1, m2, m3;
	int len;
#endif
	int i, j, sz = 50000000;

	v1 = calloc(sz, sizeof(float));
	v2 = calloc(sz, sizeof(float));

	for (i = 0; i < sz; i++)
		v1[i] = v2[i] = (float)i;

	for (res = 0.0, j = 0; j < 50; j++) {
		i = 0;
#ifdef SIMD
		len = sz - 4;
		for (m3 = _mm_setzero_ps(); i < len; i += 4) {
			m1 = _mm_load_ps(&v1[i]);
			m2 = _mm_load_ps(&v2[i]);
			m3 += m1 * m2;
		}
		_mm_store_ps(buf, m3);
		res += buf[0] + buf[1] + buf[2] + buf[3];
#endif
		for ( ; i < sz; i++) 
			res += v1[i] * v2[i];

	}
	printf("%g\n", res);
	return(EXIT_SUCCESS);
}
